package edu.ntnu.stud.chaosgame;

import edu.ntnu.stud.chaosgame.controller.game.ChaosGameDescription;
import edu.ntnu.stud.chaosgame.controller.game.ChaosGameFileHandler;
import edu.ntnu.stud.chaosgame.controller.game.ChaosCanvas;
import edu.ntnu.stud.chaosgame.controller.game.ChaosGame;
import edu.ntnu.stud.chaosgame.model.generators.ChaosGameDescriptionFactory;
import edu.ntnu.stud.chaosgame.view.ChaosGameGUIView;
import javafx.application.Application;
import javafx.stage.Stage;

import java.io.IOException;
import java.util.Objects;
import java.util.Scanner;

/**
 * Main class for the Chaos Game application.
 */
public class Main extends Application {

  @Override
  public void start(Stage primaryStage) throws IOException {
    ChaosGameGUIView view = new ChaosGameGUIView(primaryStage);

  }

  public static void main(String[] args) throws IOException {
    Scanner sc = new Scanner(System.in);
    System.out.println("Hi");
    launch(args);

    String path = "src/main/resources/descriptions/templates/sierpinski.txt";

    ChaosGameDescription description = null; // Declare description

    ChaosGame game = null;

    ChaosGameDescriptionFactory factory = new ChaosGameDescriptionFactory();

    try {
      //ChaosGameDescription description = new ChaosGameFileHandler().readFromFile(path);
      //description = new ChaosGameDescription(minCoords, maxCoords, transforms);
      //description = new ChaosGameFileHandler().readFromFile(path);
      description = factory.getDescriptions().get(1);
      ChaosCanvas canvas = new ChaosCanvas(100, 100, description.getMinCoords(), description.getMaxCoords()); // Create canvas
      game = new ChaosGame(description, canvas);

    } catch (Exception e) {
      System.out.println(e.getMessage()); // TODO: Alter error game
    }


    /* Test whether factory successfully instantiates descriptions.
    ChaosGameDescriptionFactory factory = new ChaosGameDescriptionFactory();
    for (ChaosGameDescription desc : factory.getDescriptions()) {
      System.out.println(desc);
    }*/

    boolean exit = false;

    // While loop for simple cli-app.
    while (!exit) {

      System.out.println("What would you like to do? Type 1 for displaying fractal, "
          + "or anything else for ending the program");
      if (Objects.equals(sc.next(), "1")) {
        //game.runSteps(100000);
        System.out.println(
            "What would you like to do? Type 1 for saving the fractal, anything else for ending the program");

        if (Objects.equals(sc.next(), "1")) {
          ChaosGameFileHandler handler = new ChaosGameFileHandler();
          handler.writeToFile(description, "src/main/resources/descriptions/output/output_1.txt");
          System.out.println("Wrote to file output_1.txt.");
        }
        else {
          exit = true;
        }
      }
      else {
        exit = true;
      }
    }
    System.out.println("Terminated program.");


  }
}